searchNodes=[{"doc":"This Mix Task generates a PromEx config module in your project. This config file acts as a starting point with instructions on how to set up PromEx in your application, some default PromEx metrics plugins, and their accompanying dashboards.The following CLI flags are supported:-d, --datasource The datasource that the dashboards will be reading from to populate their time series data. This `datasource` value should align with what is configured in Grafana from the Prometheus instance's `datasource_id`. -o, -otp_app The OTP application that PromEx is being installed in. This should be provided as the snake case atom (minus the leading colon). For example, if the `:app` value in your `mix.exs` file is `:my_cool_app`, this argument should be provided as `my_cool_app`. By default PromEx will read your `mix.exs` file to determine the OTP application value so this is an OPTIONAL argument.","ref":"Mix.Tasks.PromEx.Create.html","title":"Mix.Tasks.PromEx.Create","type":"task"},{"doc":"This will render a PromEx dashboard either to STDOUT or to a file depending on the CLI arguments that are provided.","ref":"Mix.Tasks.PromEx.ExportDashboard.html","title":"Mix.Tasks.PromEx.ExportDashboard","type":"task"},{"doc":"This will lint Grafana dashboards to ensure that PromEx dashboards meeting certain requirements.","ref":"Mix.Tasks.PromEx.Lint.html","title":"Mix.Tasks.PromEx.Lint","type":"task"},{"doc":"This will publish dashboards to Grafana for a PromEx module.","ref":"Mix.Tasks.PromEx.Publish.html","title":"Mix.Tasks.PromEx.Publish","type":"task"},{"doc":"PromEx is a plugin based library which can be used to capture telemetry events and report them out for consumption by Prometheus. The main purpose of this particular library is to provide the behaviour that all PromEx plugins leverage so that a consistent interface can be achieved and so that leveraging multiple plugins is effortless from the user's point of view.To use PromEx you need to define a module that uses the PromEx library. This module will also need to have some application config set for it similarly to how Ecto does. For example, for a PromEx module defined like so:defmodule MyApp.PromEx do use PromEx, otp_app: :web_app ... endYou would have an application configuration set like so:config :my_app, MyApp.PromEx, manual_metrics_start_delay: :no_delay, drop_metrics_groups: [], grafana: [ host: System.get_env(&quot;GRAFANA_HOST&quot;, &quot;http://grafana:3000&quot;), auth_token: System.get_env(&quot;GRAFANA_TOKEN&quot;, &quot;&quot;), upload_dashboards_on_start: true, folder_name: &quot;My App Dashboards&quot;, annotate_app_lifecycle: true ]The options that you can pass to PromEx macro are outlined in the following section. In order to tell PromEx what plugins you would like to use and what dashboards you would like PromEx to upload for you, implement the plugins/0 and dashboards/0 callbacks respectively. The dashboard_assigns/0 callback will be used when your EEx template Grafana dashboards are rendered so that the dashboards that are created for your application coincide with the PromEx configuration for the application. If your dashboards are not EEx templates, then the dashboard assigns are not passed through. Each plugin also has an accompanying Grafana dashboard that you can leverage to plot all of the plugin captured data.In order to expose captured metrics, you can leverage the PromEx provided Plug PromEx.Plug. See the PromEx.Plug documentation modules for specifics on how to use it.Options:otp_app - This is a REQUIRED field and is used by PromEx to fetch the application configuration values for the various PromEx caputure modules. Make sure that this value matches the :app value in project/0 from your mix.exs file. If you use the PromEx mix prom_ex.create mix task this will be done automatically for you.PromEx PluginsAll metrics collection will be delegated to plugins which can be found here:Foundational metrics:[X] PromEx.Plugins.Application Application related informational metrics[X] PromEx.Plugins.Beam BEAM virtual machine metrics[ ] Operating System (http://erlang.org/doc/man/os_mon_app.html)Library metrics:[X] Ecto (https://hexdocs.pm/ecto/Ecto.Repo.html#module-telemetry-events)[X] Oban (https://hexdocs.pm/oban/Oban.Telemetry.html)[X] Phoenix (https://hexdocs.pm/phoenix/Phoenix.Logger.html)Upcoming Elixir library metrics:[ ] Phoenix LiveView (https://hexdocs.pm/phoenix_live_view/telemetry.html)[ ] Broadway (https://hexdocs.pm/broadway/Broadway.html#module-telemetry)Backlog Elixir library metrics:[ ] Absinthe (https://hexdocs.pm/absinthe/1.5.3/telemetry.html)[ ] Dataloader (https://hexdocs.pm/dataloader/telemetry.html)[ ] GenRMQ (https://hexdocs.pm/gen_rmq/3.0.0/GenRMQ.Publisher.Telemetry.html and https://hexdocs.pm/gen_rmq/3.0.0/GenRMQ.Consumer.Telemetry.html)[ ] Plug (https://hexdocs.pm/plug/Plug.Telemetry.html)[ ] PlugCowboy (https://hexdocs.pm/plug_cowboy/2.4.0/Plug.Cowboy.html#module-instrumentation)[ ] Redix (https://hexdocs.pm/redix/Redix.Telemetry.html)[ ] Tesla (https://hexdocs.pm/tesla/Tesla.Middleware.Telemetry.html)[ ] Memcachex (https://hexdocs.pm/memcachex/0.5.0/Memcache.html#module-telemetry)[ ] Finch (https://hexdocs.pm/finch/Finch.Telemetry.html#content)[ ] Nebulex (https://hexdocs.pm/nebulex/2.0.0-rc.0/telemetry.html)[ ] Horde (https://github.com/derekkraan/horde/blob/master/lib/horde/supervisor_telemetry_poller.ex)[ ] Cachex (Need to open up PR)[ ] Quantum (https://hexdocs.pm/quantum/3.3.0/telemetry.html#content)Database cron based metrics:[ ] Postgres (https://github.com/pawurb/ecto_psql_extras for inspiration)[ ] Mnesia (https://github.com/deadtrickster/prometheus.erl/blob/master/src/collectors/mnesia/prometheus_mnesia_collector.erl for inspiration)[ ] MySQL (https://github.com/prometheus/mysqld_exporter for inspiration)[ ] Redis (https://github.com/oliver006/redis_exporter for inspiration)[ ] MongoDB (https://github.com/percona/mongodb_exporter for inspiration)","ref":"PromEx.html","title":"PromEx","type":"behaviour"},{"doc":"","ref":"PromEx.html#c:dashboard_assigns/0","title":"PromEx.dashboard_assigns/0","type":"callback"},{"doc":"","ref":"PromEx.html#c:dashboards/0","title":"PromEx.dashboards/0","type":"callback"},{"doc":"A simple pass-through to fetch all of the currently configured metrics. This is primarily used by the exporter plug to fetch all of the metrics so that they can be scraped.","ref":"PromEx.html#get_metrics/1","title":"PromEx.get_metrics/1","type":"function"},{"doc":"","ref":"PromEx.html#c:init_opts/0","title":"PromEx.init_opts/0","type":"callback"},{"doc":"","ref":"PromEx.html#c:plugins/0","title":"PromEx.plugins/0","type":"callback"},{"doc":"","ref":"PromEx.html#t:dashboard_definition/0","title":"PromEx.dashboard_definition/0","type":"type"},{"doc":"","ref":"PromEx.html#t:measurements_mfa/0","title":"PromEx.measurements_mfa/0","type":"type"},{"doc":"","ref":"PromEx.html#t:plugin_definition/0","title":"PromEx.plugin_definition/0","type":"type"},{"doc":"","ref":"PromEx.html#t:telemetry_metrics/0","title":"PromEx.telemetry_metrics/0","type":"type"},{"doc":"This module provides functions to generate histogram bucket ranges. The lists of buckets that can be generated are either linear or exponential.","ref":"PromEx.BucketGenerator.html","title":"PromEx.BucketGenerator","type":"module"},{"doc":"Create an exponential set of buckets based on the provided parameters.Examplesiex&gt; PromEx.BucketGenerator.exponential!(1, 4, 10) [1, 4, 16, 64, 256, 1024, 4096, 16384, 65536, 262144] iex&gt; PromEx.BucketGenerator.exponential!(1, 2, 10) [1, 2, 4, 8, 16, 32, 64, 128, 256, 512]","ref":"PromEx.BucketGenerator.html#exponential!/3","title":"PromEx.BucketGenerator.exponential!/3","type":"function"},{"doc":"Create a linear set of buckets based on the provided parameters.Examplesiex&gt; PromEx.BucketGenerator.linear!(10, 10, 10) [10, 20, 30, 40, 50, 60, 70, 80, 90, 100] iex&gt; PromEx.BucketGenerator.linear!(0, 250, 11) [0, 250, 500, 750, 1000, 1250, 1500, 1750, 2000, 2250, 2500]","ref":"PromEx.BucketGenerator.html#linear!/3","title":"PromEx.BucketGenerator.linear!/3","type":"function"},{"doc":"This module defines a struct that contains all of the fields necessary to configure an instance of PromEx.While this module does not directly access your Application config, PromEx will call the PromEx.Config.build/1 function directly with the contents of Application.get_env(:your_otp_app, YourPromEx.Module). As such, this is an appropriate place to talk about how you go about configuring PromEx via your Application config.By default, you can run PromEx without any additional configuration and PromEx will fall back on some sane defaults. Specifically, if you were to not add any configuration to your config.exs, dev.exs, prod.exs, etc files it would be the same as setting the following config:config :web_app, WebApp.PromEx, manual_metrics_start_delay: :no_delay, drop_metrics_groups: [], grafana: :disabled, metrics_server: :disabledIn this configuration, the Grafana dashboards are not uploaded on application start, and a standalone HTTP metrics server is not started. In addition, the PromEx.ManualMetricsManager is started without any time delay, and all metrics groups from all the plugins are regestered and set up.If you would like to set up PromEx to communicate with Grafana, your config would look something like:config :web_app, WebApp.PromEx, grafana: [ host: &quot;http://localhost:3000&quot;, auth_token: &quot;&lt;YOUR_AUTH_TOKEN_HERE&gt;&quot;, upload_dashboards_on_start: true # This is an optional setting and will default to `true` ]If you would like PromEx to start a standalone HTTP server to serve your aggregated metrics, you can leverage the :metrics_server config:config :web_app, WebApp.PromEx, metrics_server: [ port: 4021, path: &quot;/metrics&quot;, # This is an optional setting and will default to `&quot;/metrics&quot;` protocol: :http, # This is an optional setting and will default to `:http` pool_size: 5, # This is an optional setting and will default to `5` cowboy_opts: [], # This is an optional setting and will default to `[]` auth_strategy: :none # This is an optional and will default to `:none` ]If you would like the metrics server to be protected behind some sort of authentication, you can configure your :metrics_server like so:config :web_app, WebApp.PromEx, metrics_server: [ port: 4021, auth_strategy: :bearer, auth_token: &quot;VGhpcyBpcyBzdXBlciBzZWNyZXQuLi5kb24ndCBkZWNvZGUgbWU=&quot; ]Option Details:manual_metrics_start_delay - Manual metrics are gathered once on start up and then only when you call PromEx.ManualMetricsManager.refresh_metrics/1. Sometimes, you may have metrics that require your entire supervision tree to be started in order to fetch accurate data. This option will allow you to delays the initial metrics capture of the ManualMetricsManager by a certain number of milliseconds or the :no_delay atom if you want the metrics to be captured as soon as the ManualMetricsManager starts up. Default value: :no_delay:drop_metrics_groups - A list of all the metrics groups that you are not interested in tracking. For example, if your application does not leverage Phoenix channels at all but you still would like to use the PromEx.Plugins.Phoenix plugin, you can pass [:phoenix_channel_event_metrics] as the value to :drop_metrics_groups and that set of metrics will not be caputred. Default value: []:grafana - This key contains the configuration information for connecting to Grafana. Its configuration options are::host - The host address of your Grafana instance. In order for PromEx to communicate with Grafana this valueshould be in the format protocol://host:port like http://localhost:3000 for example.:auth_token - The auth token that was created in Grafana so that PromEx can upload dashboards via the API.:upload_dashboards_on_start - Using the config values that you set in your application config (config.exs, dev.exs, prod.exs, etc) PromEx will attempt to upload your Dashboards to Grafana using Grafana's HTTP API.:folder_name - The name of the folder that PromEx will put all of the project dashboards in. PromEx will automatically generate a unique ID for the folder based on the project's otp_app value so that it can access the correct folder in Grafana. This also makes sure that differnt Elixir projects running in the same cluster and publishing dashboards to Grafana do not collide with one another. If no name is provided, then the dashboards will all be uploaded to the default Grafana folder.:annotate_app_lifecycle - By enabling this setting, PromEx will leverage the Grafana API to annotate when the application was started, and when it was shut down. By default this is disabled but if you do enable it, no action is required from you in order to display these events on the dashboards. The annotations will automatically contain the necessary tags to only display on the PromEx dashboards. The annotation will include information including:HostnameOTP app nameApp versionGit SHA of the last commit (if the GIT_SHA environment variable is present)Git author of the last commit (if the GIT_AUTHOR environment variable is present):metrics_server - This key contains the configuration information needed to run a standalone HTTP server powered by Cowboy. This server provides a lightweight solution to serving up PromEx metrics. Its configuration options are::port - The port that the Cowboy HTTP server should run on.:path - The path that the metrics should be accessible at.:protocol - The protocol that the metrics should be accessible over (:http or :https).:pool_size - How many Cowboy processes should be in the pool to handle metrics related requests.:auth_strategy - What authentication strategy should be used to authorize requests to your metrics. The Supported strategies are :none, :bearer, and :basic. Depending on what strategy is selected, you will need to also add additional config values. For :none (which is the default), no additional information needs to be provided. When using a :bearer strategy, you'll need to provide a :auth_token config value. When using :basic strategy you'll need to provide :auth_user and :auth_password values.:auth_token - When using a :bearer authentication strategy, this field is required to validate the incoming request against a valid auth token.:auth_user - When using a :basic authentication strategy, this field is required to validate the incoming request against a valid user.:auth_password - When using a :bearer authentication strategy, this field is required to validate the incoming request against a valid password.:cowboy_opts - A keyword list of any additional options that should be passed to Plug.Cowboy (see docs for more information https://hexdocs.pm/plug_cowboy/Plug.Cowboy.html). The :port and :transport_options options are handled by PromEx via the aforementioned config settings and so adding them again here has no effect.","ref":"PromEx.Config.html","title":"PromEx.Config","type":"module"},{"doc":"Create a struct that encapsulates all of the configuration needed to start a PromEx supervisor instance as well as all of the worker processes.","ref":"PromEx.Config.html#build/1","title":"PromEx.Config.build/1","type":"function"},{"doc":"manual_metrics_start_delay: How the ManualMetricsManager worker process should be started (instantly or with a millisecond delay).drop_metrics_groups: A list of metrics groups that should be omitted from the metrics collection process.grafana_config: A map containing all the relevant settings to connect to Grafana.metrics_server_config: A map containing all the relevant settings to start a standalone HTTP Cowboy server for metrics.","ref":"PromEx.Config.html#t:t/0","title":"PromEx.Config.t/0","type":"type"},{"doc":"This module is used to read dashboard definitions, render EEx dashboards, and ensure that requested files actually exist","ref":"PromEx.DashboardRenderer.html","title":"PromEx.DashboardRenderer","type":"module"},{"doc":"Read the contents of a dashboard file entry. If an EEx version of the file exists, read that, else fallback to the provided file name. For example, if the requested dashboard file is ecto.json, if ecto.json.eex exists, then that will be returned. This is more so for convenience so that you don't need to write out .eex everywhere given that all PromEx 1st party dashboards are EEx templates.","ref":"PromEx.DashboardRenderer.html#build/2","title":"PromEx.DashboardRenderer.build/2","type":"function"},{"doc":"This function will decode the JSON dashboard using Jason. If any errors occur during the decoding process, the struct will be marked as having invalid JSON.","ref":"PromEx.DashboardRenderer.html#decode_dashboard/1","title":"PromEx.DashboardRenderer.decode_dashboard/1","type":"function"},{"doc":"This function will merge in the provided assigns to the struct's assigns. These assigns will then be used during the render_dashboard/1 call to render any EEx template statements.","ref":"PromEx.DashboardRenderer.html#merge_assigns/2","title":"PromEx.DashboardRenderer.merge_assigns/2","type":"function"},{"doc":"Renders the dashboard. If it is an EEx file then the PromEx module assigns are passed. Else if it is a raw json file then it is passed through untouched.","ref":"PromEx.DashboardRenderer.html#render_dashboard/1","title":"PromEx.DashboardRenderer.render_dashboard/1","type":"function"},{"doc":"","ref":"PromEx.DashboardRenderer.html#t:t/0","title":"PromEx.DashboardRenderer.t/0","type":"type"},{"doc":"This GenServer is responsible for uploading the configured PromEx module dashboards to Grafana. This is a transient process and will terminate after the dashboards have been successfully uploaded. It requires the name of the PromEx module as an option so that it can look into the application config for the appropriate Grafana settings. For example, if the name of the PromEx module is WebApp.PromEx, then your config chould provide the following settings:config :web_app, WebApp.PromEx, grafana_host: &quot;&lt;YOUR HOST ADDRESS&gt;&quot;, grafana_auth_token: &quot;&lt;YOUR GRAFANA AUTH TOKEN&gt;&quot;","ref":"PromEx.DashboardUploader.html","title":"PromEx.DashboardUploader","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"PromEx.DashboardUploader.html#child_spec/1","title":"PromEx.DashboardUploader.child_spec/1","type":"function"},{"doc":"Used to start the DashboardUploader process","ref":"PromEx.DashboardUploader.html#start_link/1","title":"PromEx.DashboardUploader.start_link/1","type":"function"},{"doc":"This is a convenience module used for debugging and introspecting telemetry events. Primarily used to ease for development or PromEx itself.","ref":"PromEx.Debug.html","title":"PromEx.Debug","type":"module"},{"doc":"Use this function to attach a debugger handler to a certain telemetry event.","ref":"PromEx.Debug.html#attach_debugger/1","title":"PromEx.Debug.attach_debugger/1","type":"function"},{"doc":"This module is used by the Mix tasks that are available in PromEx to update dashboards in Grafana and also by the PromEx.DashboardUpdater to update dashboards automatically on application initialization.Dashboard models: https://grafana.com/docs/grafana/latest/dashboards/json-model/","ref":"PromEx.GrafanaClient.html","title":"PromEx.GrafanaClient","type":"module"},{"doc":"Used to create annotations on dashboard panels","ref":"PromEx.GrafanaClient.html#create_annotation/3","title":"PromEx.GrafanaClient.create_annotation/3","type":"function"},{"doc":"Used to create a new folder in Grafana","ref":"PromEx.GrafanaClient.html#create_folder/3","title":"PromEx.GrafanaClient.create_folder/3","type":"function"},{"doc":"Used to get the dashboard definition currently in Grafana for the provided dashboard file. If the ID does not exist in Grafana an error tuple will be returned.","ref":"PromEx.GrafanaClient.html#get_dashboard/2","title":"PromEx.GrafanaClient.get_dashboard/2","type":"function"},{"doc":"Used to fetch the details regarding a particular folder on Grafana","ref":"PromEx.GrafanaClient.html#get_folder/2","title":"PromEx.GrafanaClient.get_folder/2","type":"function"},{"doc":"Update an existing folder in Grafana","ref":"PromEx.GrafanaClient.html#update_folder/3","title":"PromEx.GrafanaClient.update_folder/3","type":"function"},{"doc":"Used to create a new dashboard or update an existing dashboard.","ref":"PromEx.GrafanaClient.html#upload_dashboard/3","title":"PromEx.GrafanaClient.upload_dashboard/3","type":"function"},{"doc":"This struct encapsulates all of the data necessary to connect to a Grafana instance.","ref":"PromEx.GrafanaClient.Connection.html","title":"PromEx.GrafanaClient.Connection","type":"module"},{"doc":"Build a connection struct for connecting to Grafana.","ref":"PromEx.GrafanaClient.Connection.html#build/3","title":"PromEx.GrafanaClient.Connection.build/3","type":"function"},{"doc":"","ref":"PromEx.GrafanaClient.Connection.html#t:t/0","title":"PromEx.GrafanaClient.Connection.t/0","type":"type"},{"doc":"This module is used to validate Grafana dashboard to ensure that they adhere to certain style and structure requirements.","ref":"PromEx.GrafanaClient.DashboardChecker.html","title":"PromEx.GrafanaClient.DashboardChecker","type":"module"},{"doc":"This GenServer is responsible to keeping track of the life cycle of the application and sending annotation requests to Grafana when the application starts and when it terminates. It will include things in the message like:HostnameOTP app nameApp versionGit SHA of the last commit (if the GIT_SHA environment variable is present)Git author of the last commit (if the GIT_AUTHOR environment variable is present)","ref":"PromEx.LifecycleAnnotator.html","title":"PromEx.LifecycleAnnotator","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"PromEx.LifecycleAnnotator.html#child_spec/1","title":"PromEx.LifecycleAnnotator.child_spec/1","type":"function"},{"doc":"Used to start the PromEx.LifecycleAnnotator process.","ref":"PromEx.LifecycleAnnotator.html#start_link/1","title":"PromEx.LifecycleAnnotator.start_link/1","type":"function"},{"doc":"This GenServer is responsible to keeping track of all the manual metrics from your configured plugins. It will fetch metrics initially when starting (either immediately or after a configured delay). At that point if you would like to refresh your metrics data points call the refresh_metrics/1 function.","ref":"PromEx.ManualMetricsManager.html","title":"PromEx.ManualMetricsManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"PromEx.ManualMetricsManager.html#child_spec/1","title":"PromEx.ManualMetricsManager.child_spec/1","type":"function"},{"doc":"This function calls into the GenServer and refreshes all of the configured manual metrics data points.","ref":"PromEx.ManualMetricsManager.html#refresh_metrics/1","title":"PromEx.ManualMetricsManager.refresh_metrics/1","type":"function"},{"doc":"Used to start the PromEx.ManualMetricsManager process","ref":"PromEx.ManualMetricsManager.html#start_link/1","title":"PromEx.ManualMetricsManager.start_link/1","type":"function"},{"doc":"This struct defines the fields necessary to export a group of standard metrics from a plugin.","ref":"PromEx.MetricTypes.Event.html","title":"PromEx.MetricTypes.Event","type":"module"},{"doc":"Create a struct that encompasses a group of event based metrics. The group_name should be unique and should follow the following convention: &lt;APPLICATION&gt;_&lt;SHORT DESCRIPTION&gt;_event_metrics. For example, Phoenix HTTP related metrics have a group_name of: :phoenix_http_event_metrics","ref":"PromEx.MetricTypes.Event.html#build/2","title":"PromEx.MetricTypes.Event.build/2","type":"function"},{"doc":"group_name: A unique identifier for the collection of metrics.metrics: A list of Telemetry Metrics structs that define the metrics.","ref":"PromEx.MetricTypes.Event.html#t:t/0","title":"PromEx.MetricTypes.Event.t/0","type":"type"},{"doc":"This struct defines the fields necessary to export a group of manually collected metric sources from a plugin.","ref":"PromEx.MetricTypes.Manual.html","title":"PromEx.MetricTypes.Manual","type":"module"},{"doc":"Create a struct that encompasses a group of manually triggered metrics. The group_name should be unique and should follow the following convention: &lt;APPLICATION&gt;_&lt;SHORT DESCRIPTION&gt;_manual_metrics. For example, Application related info metrics have a group_name of: :application_versions_manual_metrics","ref":"PromEx.MetricTypes.Manual.html#build/3","title":"PromEx.MetricTypes.Manual.build/3","type":"function"},{"doc":"group_name: A unique identifier for the collection of metrics.measurements_mfa: An MFA tuple that defines what function will be executed that will emit Telemetry events.metrics: A list of Telemetry Metrics structs that define the metrics.","ref":"PromEx.MetricTypes.Manual.html#t:t/0","title":"PromEx.MetricTypes.Manual.t/0","type":"type"},{"doc":"This struct defines the fields necessary to export a group of pollable metric sources from a plugin.","ref":"PromEx.MetricTypes.Polling.html","title":"PromEx.MetricTypes.Polling","type":"module"},{"doc":"Create a struct that encompasses a group of polling type metrics. The group_name should be unique and should follow the following convention: &lt;APPLICATION&gt;_&lt;SHORT DESCRIPTION&gt;_manual_metrics. For example, BEAM related memory metrics have a group_name of: :beam_memory_polling_events","ref":"PromEx.MetricTypes.Polling.html#build/4","title":"PromEx.MetricTypes.Polling.build/4","type":"function"},{"doc":"group_name: A unique identifier for the collection of metrics.measurements_mfa: An MFA tuple that defines what function will be executed that will emit Telemetry events.metrics: A list of Telemetry Metrics structs that define the metrics.poll_rate: An integer representing the millisecond between metrics samples.","ref":"PromEx.MetricTypes.Polling.html#t:t/0","title":"PromEx.MetricTypes.Polling.t/0","type":"type"},{"doc":"This plug is used to serve metrics when PromEx is run in a standalone server configuration. This plug supports the following options::path - The route that should expose the metrics (default is &quot;/metrics&quot;):prom_ex_module - The PromEx module that this plug will expose","ref":"PromEx.MetricsServer.Plug.html","title":"PromEx.MetricsServer.Plug","type":"module"},{"doc":"Use this plug in your Endpoint file to expose your metrics. The following options are supported by this plug::prom_ex_module - The PromEx module whose metrics will be plublished through this particular plug:path - The path through which your metrics can be accessed (default is &quot;/metrics&quot;)If you need to have some sort of access control around your metrics endpoint, I would suggest looking at another library that I maintain called Unplug(https://hex.pm/packages/unplug). Using Unplug, you can skip over this plug if some sort of requirement is not fulfilled. For example, if you wanted to configure the metrics endpoint to only be accessible if the request has an Authorization header that matches a configured environment variable you could do something like so using Unplug:defmodule MyApp.UnplugPredicates.SecureMetricsEndpoint do @behaviour Unplug.Predicate @impl true def call(conn, env_var) do auth_header = Plug.Conn.get_req_header(conn, &quot;authorization&quot;) System.get_env(env_var) == auth_header end endWhich can then be used in your endpoint.ex file like so:plug Unplug, if: {MyApp.UnplugPredicates.SecureMetricsEndpoint, &quot;PROMETHEUS_AUTH_SECRET&quot;}, do: {PromEx.Plug, prom_ex_module: MyApp.PromEx}The reason that this functionality is not part of PromEx itself is that how you chose to configure the visibility of the metrics route is entirely up to the user and so it felt as though this plug would be over complicated by having to support application config, environment variables, etc. And given that Unplug exists for this purpose, it is the recommended tool for the job.","ref":"PromEx.Plug.html","title":"PromEx.Plug","type":"module"},{"doc":"This module defines the behaviour that PromEx plugins need to implement in order to be properly loaded by PromEx on application start. As a convenience, this module can also be used as a macro to automatically import all of the necessary utility functions for writing plugins and also providing default implementations of behaviour functions that you may not be implementing.","ref":"PromEx.Plugin.html","title":"PromEx.Plugin","type":"behaviour"},{"doc":"The event_metrics/1 callback returns the configured event based metrics that the plugin exposes. If the plugin does not expose any event style metrics, there is a default implementation of this function that returns an empty list. In other words, if your plugin does not expose any event style metrics, there is no action needed on your part.This function is expected to either return a single PromEx.Plugins.Event struct or a list of PromEx.Plugins.Event structs.","ref":"PromEx.Plugin.html#c:event_metrics/1","title":"PromEx.Plugin.event_metrics/1","type":"callback"},{"doc":"The manual_metrics/1 callback returns the configured manual based metrics that the plugin exposes. If the plugin does not expose any manual style metrics, there is a default implementation of this function that returns an empty list. In other words, if your plugin does not expose any manual style metrics, there is no action needed on your part.This function is expected to either return a single PromEx.Plugins.Manual struct or a list of PromEx.Plugins.Manual structs.","ref":"PromEx.Plugin.html#c:manual_metrics/1","title":"PromEx.Plugin.manual_metrics/1","type":"callback"},{"doc":"The polling_metrics/1 callback returns the configured polling based metrics that the plugin exposes. If the plugin does not expose any polling style metrics, there is a default implementation of this function that returns an empty list. In other words, if your plugin does not expose any polling style metrics, there is no action needed on your part.This function is expected to either return a single PromEx.Plugins.Polling struct or a list of PromEx.Plugins.Polling structs.","ref":"PromEx.Plugin.html#c:polling_metrics/1","title":"PromEx.Plugin.polling_metrics/1","type":"callback"},{"doc":"This plugin captures metrics regarding your application, and its dependencies. Specifically, it captures the versions of your application and the application dependencies and also how many modules each dependency is bringing into the project.This plugin supports the following options:otp_app: This is a REQUIRED option and is the name of you application in snake case (e.g. :my_cool_app).deps: This option is OPTIONAL and defines what dependencies the plugin should track. A value of :all means that PromEx will fetch details on all application dependencies. A list of dependency names like [:phoenix, :ecto, :unplug] means that PromEx will only fetch details regarding those dependencies.git_sha_mfa: This option is OPTIONAL and defines an MFA that will be called in order to fetch the application's Git SHA at the time of deployment. By default, an Application Plugin function will be called and will attempt to read the GIT_SHA environment variable to populate the value.git_author_mfa: This option is OPTIONAL and defines an MFA that will be called in order to fetch the application's last Git commit author at the time of deployment. By default, an Application Plugin function will be called and will attempt to read the GIT_AUTHOR environment variable to populate the value.This plugin exposes the following metric groups::application_versions_manual_metricsTo use plugin in your application, add the following to your application supervision tree:def start(_type, _args) do children = [ ... { PromEx, plugins: [ {PromEx.Plugins.Application, [otp_app: :my_cool_app]}, ... ], delay_manual_start: :no_delay } ] opts = [strategy: :one_for_one, name: WebApp.Supervisor] Supervisor.start_link(children, opts) endThis plugin exposes manual metrics so be sure to configure the PromEx :delay_manual_start as required.","ref":"PromEx.Plugins.Application.html","title":"PromEx.Plugins.Application","type":"module"},{"doc":"Telemetry metrics for the BEAM.This plugin captures metrics regarding the Erlang Virtual Machine (i.e the BEAM). Specifically, it captures metrics regarding the CPU topology, system limits, VM feature support, scheduler information, memory utilization, distribution traffic, and other internal metrics.This plugin supports the following options:poll_rate: This is option is OPTIONAL and is the rate at which poll metrics are refreshed (default is 5 seconds).This plugin exposes the following metric groups::beam_memory_polling_metrics:beam_internal_polling_metrics:beam_cpu_topology_manual_metrics:beam_system_limits_manual_metrics:beam_system_info_manual_metrics:beam_scheduler_manual_metricsTo use plugin in your application, add the following to your PromEx module:defmodule MyApp.PromEx do use PromEx, otp_app: :web_app @impl true def plugins do [ ... PromEx.Plugins.Beam ] end @impl true def dashboards do [ ... {:prom_ex, &quot;beam.json&quot;} ] end endThis plugin exposes manual metrics so be sure to configure the PromEx :delay_manual_start as necessary.","ref":"PromEx.Plugins.Beam.html","title":"PromEx.Plugins.Beam","type":"module"},{"doc":"This plugin captures metrics emitted by Ecto. Be sure that your PromEx module is listed before your Repo module in your supervision tree so that the Ecto init events are not missed. If you miss those events the dashboard variable dropdowns for the repo value will be broken.This plugin supports the following options:otp_app: This is a REQUIRED option and is the name of you application in snake case (e.g. :my_cool_app).repos: This is an OPTIONAL option and is a list with the full module name of your Ecto Repos (e.g [MyApp.Repo]). If you do not provide this value, PromEx will attempt to resolve your Repo modules via the :ecto_repos configuration on your OTP app.This plugin exposes the following metric groups::ecto_init_event_metrics:ecto_query_event_metricsTo use plugin in your application, add the following to your PromEx module plugins/0 function:def plugins do [ ... {PromEx.Plugins.Ecto, otp_app: :web_app, repos: [WebApp.Repo]} ] end","ref":"PromEx.Plugins.Ecto.html","title":"PromEx.Plugins.Ecto","type":"module"},{"doc":"This plugin captures metrics emitted by Oban. Specifically, it captures metrics from job events, producer events, and also from internal polling jobs to monitor queue sizesThis plugin supports the following options:oban_supervisors: This is an OPTIONAL option and it allows you to specify what Oban instances should have their events tracked. By default the only Oban instance will have its events tracked is the defualt Oban instance. As a result, by default this option has a value of [Oban]. If you would like to track other named Oban instances, or perhaps your default and only Oban instance has a different name, you can pass in your own list of Oban instances (e.g. [Oban, Oban.PrivateJobs]).poll_rate: This is option is OPTIONAL and is the rate at which poll metrics are refreshed (default is 5 seconds).This plugin exposes the following metric groups::oban_init_event_metrics:oban_job_event_metrics:oban_producer_event_metrics:oban_circuit_event_metrics:oban_queue_poll_metricsTo use plugin in your application, add the following to your PromEx module:defmodule WebApp.PromEx do use PromEx, otp_app: :web_app @impl true def plugins do [ ... {PromEx.Plugins.Oban, queues: [:default, :media, :events], poll_rate: 10_000} ] end @impl true def dashboards do [ ... {:prom_ex, &quot;oban.json&quot;} ] end end","ref":"PromEx.Plugins.Oban.html","title":"PromEx.Plugins.Oban","type":"module"},{"doc":"","ref":"PromEx.Plugins.Oban.html#oban_circuit_breaker_event_metrics/2","title":"PromEx.Plugins.Oban.oban_circuit_breaker_event_metrics/2","type":"function"},{"doc":"This plugin captures metrics emitted by Phoenix. Specifically, it captures HTTP request metrics and Phoenix channel metrics.This plugin supports the following options:router: This is a REQUIRED option and is the full module name of your Phoenix Router (e.g MyAppWeb.Router).event_prefix: This option is OPTIONAL and allows you to set the event prefix for the Telemetry events. This value should align with what you pass to Plug.Telemetry in your endpoint.ex file (see the plug docs for more information https://hexdocs.pm/plug/Plug.Telemetry.html)This plugin exposes the following metric groups::phoenix_http_event_metrics:phoenix_channel_event_metricsTo use plugin in your application, add the following to your PromEx module:defmodule WebApp.PromEx do use PromEx, otp_app: :web_app @impl true def plugins do [ ... {PromEx.Plugins.Phoenix, router: WebAppWeb.Router} ] end @impl true def dashboards do [ ... {:prom_ex, &quot;phoenix.json&quot;} ] end end","ref":"PromEx.Plugins.Phoenix.html","title":"PromEx.Plugins.Phoenix","type":"module"},{"doc":"Prometheus Reporter for Telemetry.Metrics definitions.Provide a list of metric definitions to the child_spec/1 function. It's recommended to add this to your supervision tree.def start(_type, _args) do # List all child processes to be supervised children = [ {PromEx.TelemetryMetricsPrometheus.Core, [ metrics: [ counter(&quot;http.request.count&quot;), sum(&quot;http.request.payload_size&quot;, unit: :byte), last_value(&quot;vm.memory.total&quot;, unit: :byte) ] ]} ] opts = [strategy: :one_for_one, name: ExampleApp.Supervisor] Supervisor.start_link(children, opts) endNote that aggregations for distributions (histogram) only occur at scrape time. These aggregations only have to process events that have occurred since the last scrape, so it's recommended at this time to keep an eye on scrape durations if you're reporting a large number of distributions or you have a high tag cardinality.Telemetry.Metrics to Prometheus EquivalentsMetric types:Counter - CounterDistribution - HistogramLastValue - GaugeSum - CounterSummary - Summary (Not supported)UnitsPrometheus recommends the usage of base units for compatibility - Base Units. This is simple to do with :telemetry and Telemetry.Metrics as all memory related measurements in the BEAM are reported in bytes and Metrics provides automatic time unit conversions.Note that measurement unit should used as part of the reported name in the case of histograms and gauges to Prometheus. As such, it is important to explicitly define the unit of measure for these types when the unit is time or memory related.It is suggested to not mix units, e.g. seconds with milliseconds.It is required to define your buckets according to the end unit translation since this measurements are converted at the time of handling the event, prior to bucketing.MemoryReport memory as :byte.TimeReport durations as :second. The BEAM and :telemetry events use :native time units. Converting to seconds is as simple as adding the conversion tuple for the unit - {:native, :second}NamingTelemetry.Metrics definition names do not translate easily to Prometheus naming conventions. By default, the name provided when creating your definition uses parts of the provided name to determine what event to listen to and which event measurement to use.For example, &quot;http.request.duration&quot; results in listening for [:http, :request] events and use :duration from the event measurements. Prometheus would recommend a name of http_request_duration_seconds as a good name.It is therefore recommended to use the name in your definition to reflect the name you wish to see reported, e.g. http.request.duration.seconds or [:http, :request, :duration, :seconds] and use the :event_name override and :measurement options in your definition.Example:Metrics.distribution( &quot;http.request.duration.seconds&quot;, event_name: [:http, :request, :complete], measurement: :duration, unit: {:native, :second}, reporter_options: [ buckets: [0.01, 0.025, 0.05, 0.1, 0.2, 0.5, 1] ] )The exporter sanitizes names to Prometheus' requirements (Metric Naming) and joins the event name parts with an underscore.LabelsLabels in Prometheus are referred to as :tags in Telemetry.Metrics - see the docs for more information on tag usage.Important: Each tag + value results in a separate time series. For distributions, this is further complicated as a time series is created for each bucket plus one for measurements exceeding the limit of the last bucket - +Inf.It is recommended, but not required, to abide by Prometheus' best practices regarding labels - Label Best PracticesMissing or Invalid Measurements and TagsIf a measurement value is missing or non-numeric, the error is logged at the debug level and the event is not recorded. Events with missing tags are also logged and skipped.","ref":"PromEx.TelemetryMetricsPrometheus.Core.html","title":"PromEx.TelemetryMetricsPrometheus.Core","type":"module"},{"doc":"Reporter's child spec.This function allows you to start the reporter under a supervisor like this:children = [ {PromEx.TelemetryMetricsPrometheus.Core, options} ]See start_child/1 for options.","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#child_spec/1","title":"PromEx.TelemetryMetricsPrometheus.Core.child_spec/1","type":"function"},{"doc":"Returns a metrics scrape in Prometheus exposition format for the given reporter name - defaults to :prometheus_metrics.","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#scrape/1","title":"PromEx.TelemetryMetricsPrometheus.Core.scrape/1","type":"function"},{"doc":"Start the PromEx.TelemetryMetricsPrometheus.Core.SupervisorAvailable options::name - name of the reporter instance. Defaults to :prometheus_metrics:metrics - a list of metrics to track.","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#start_link/1","title":"PromEx.TelemetryMetricsPrometheus.Core.start_link/1","type":"function"},{"doc":"","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#t:metrics/0","title":"PromEx.TelemetryMetricsPrometheus.Core.metrics/0","type":"type"},{"doc":"","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#t:prometheus_option/0","title":"PromEx.TelemetryMetricsPrometheus.Core.prometheus_option/0","type":"type"},{"doc":"","ref":"PromEx.TelemetryMetricsPrometheus.Core.html#t:prometheus_options/0","title":"PromEx.TelemetryMetricsPrometheus.Core.prometheus_options/0","type":"type"},{"doc":"PromEx Prometheus metrics and Grafana dashboards for all of your favorite Elixir libraries.ContentsInstallationDesign PhilosophyAvailable PluginsGrafana DashboardsSetting Up MetricsPerformance ConcernsAttribution","ref":"readme.html","title":"PromEx","type":"extras"},{"doc":"This library is still under active development with changing API contracts and forked dependencies...use at your own risk for now :).Available in Hex, the package can be installed by adding prom_ex to your list of dependencies in mix.exs:def deps do [ {:prom_ex, &quot;~&gt; 0.1.13-beta&quot;} ] endDocumentation can be found at https://hexdocs.pm/prom_ex.Design PhilosophyWith the widespread adoption of the Telemetry library and the other libraries in the BEAM Telemetry GitHub Org, we have reached a point where we have a consistent means of surfacing application and library metrics. This allows us to have a great level of insight into our applications and dependencies given that they all leverage the same fundamental tooling. The goal of this project is to provide a &quot;Plug-in&quot; style library where you can easily add new plug-ins to surface metrics so that Prometheus can scrape them. Ideally, this project acts as the &quot;Metrics&quot; pillar in your application (in reference to The Three Pillars of Observability).To this end, while PromEx does provide a certain level of configurability (like the polling rate, starting behaviour for manual metrics and all the options that the plugins receive), the goal is not to make an infinitely configurable tool. For example, you are not able to edit the names/descriptions of Prometheus metrics via plugin options or even the tags that are attached to the data points.Instead, if there things that you don't agree with or that are incompatible with your usage of a certain 1st party plugin and want to edit how the PromEx plugins react to Telemetry events, it is recommended that you fork the plugin in question and edit it to your specific use case. If you think that the community can benefit for your changes, do not hesitate to make a PR and I'll be sure to review it. This is not to say that event configurability will never come to PromEx, but I want to make sure that the public facing API is clean and straightforward and not bogged down with configuration. That and the Grafana dashboards would then have to become templatized to accommodate all this configurability.PromEx provides a few utilities to you in order to accomplish this goal:The PromEx.Plug module that can be used in your Phoenix or Plug application to expose the collected metricsA Mix task to upload the provided complimentary Grafana dashboardsA Mix task to create a PromEx metrics capture moduleA behaviour that defines the contract for PromEx plug-insA behaviour that defines the functionality of a PromEx metrics capture moduleGrafana dashboards tailored to each specific Plugin so that metrics work out of the box with dashboardsAvailable PluginsPluginStatusDescriptionPromEx.Plugins.ApplicationBetaCollect metrics on your application dependenciesPromEx.Plugins.BeamBetaCollect metrics regarding the BEAM virtual machinePromEx.Plugins.PhoenixBetaCollect request metrics emitted by PhoenixPromEx.Plugins.EctoBetaCollect query metrics emitted by EctoPromEx.Plugins.ObanBetaCollect queue processing metrics emitted by ObanPromEx.Plugins.PhoenixLiveViewComing soonCollect metrics emitted by Phoenix LiveViewPromEx.Plugins.AbsintheComing soonCollect GraphQL metrics emitted by AbsinthePromEx.Plugins.BroadwayComing soonCollect message processing metrics emitted by BroadwayPromEx.Plugins.FinchComing soonCollect HTTP request metrics emitted by FinchPromEx.Plugins.RedixComing soonCollect Redis request metrics emitted by RedixMore to come...Grafana DashboardsPromEx comes with a custom tailored Grafana Dashboard per Plugin. Click here to check out sample screenshots of each Plugin specific Grafana Dashbaord.Setting Up MetricsThe goal of PromEx is to have metrics set up be as simple and streamlined as possible. In that spirit, all that you need to do to start leveraging PromEx along with the built-in plugins is to run the following mix task:$ mix prom_ex.create --datasource YOUR_PROMETHEUS_DATASOURCE_IDThen add the generated module to your application.ex file supervision tree:defmodule MyCoolApp.Application do use Application def start(_type, _args) do children = [ ... MyCoolApp.PromEx ] opts = [strategy: :one_for_one, name: MyCoolApp.Supervisor] Supervisor.start_link(children, opts) end endWith that in place, all that you need to do is then add the PromEx plug somewhere in your endpoint.ex file (I would suggest putting it before your plug Plug.Telemetry call so that you do not pollute your logs with calls to /metrics):defmodule MyCoolAppWeb.Endpoint do use Phoenix.Endpoint, otp_app: :my_cool_app ... plug PromEx.Plug, prom_ex_module: MyCoolApp.PromEx # Or plug PromEx.plug, path: &quot;/some/other/metrics/path&quot;, prom_ex_module: MyCoolApp.PromEx ... plug Plug.RequestId plug Plug.Telemetry, event_prefix: [:phoenix, :endpoint] ... plug MyCoolAppWeb.Router endWith that in place, all you need to do is start your server and you should be able to hit your metrics endpoint and see your application metrics:$ curl localhost:4000/metrics # HELP my_cool_app_application_dependency_info Information regarding the application's dependencies. # TYPE my_cool_app_application_dependency_info gauge my_cool_app_application_dependency_info{modules=&quot;69&quot;,name=&quot;hex&quot;,version=&quot;0.20.5&quot;} 1 my_cool_app_application_dependency_info{modules=&quot;1&quot;,name=&quot;connection&quot;,version=&quot;1.0.4&quot;} 1 my_cool_app_application_dependency_info{modules=&quot;4&quot;,name=&quot;telemetry_poller&quot;,version=&quot;0.5.1&quot;} 1 ... ...Be sure to check out the module docs for each plugin that you choose to use to ensure that you are familiar with all of the options that they provide.Performance ConcernsYou may think to yourself that with all these metrics being collected and scraped, that the performance of your application my be negatively impacted. Luckily PromEx is built upon the solid foundation established by the Telemetry, TelemetryMetrics, and the TelemetryMetricsPrometheus projects. These libraries were designed to be as lightweight and performant as possible. From some basic stress tests that I have run, I have been unable to observe any meaningful or measurable performance reduction (thank you OTP and particularly ETS ;)). Here are six sample stress tests using wrk2 with PromEx enabled and disabled with the following configuration:defmodule WebApp.PromEx use PromEx, otp_app: :web_app @impl true def plugins do [ {PromEx.Plugins.Application, otp_app: :web_app}, PromEx.Plugins.Beam, {PromEx.Plugins.Phoenix, router: WebAppWeb.Router} ] end endWith out PromEx metrics collection:$ wrk2 -t5 -c50 -R 1000 -d10s 'http://localhost:4000/' Running 10s test @ http://localhost:4000/ 5 threads and 50 connections Thread Stats Avg Stdev Max +/- Stdev Latency 4.25ms 1.02ms 22.00ms 71.90% Req/Sec -nan -nan 0.00 0.00% 10003 requests in 10.01s, 38.60MB read Requests/sec: 999.78 Transfer/sec: 3.86MB $ wrk2 -t5 -c50 -R 1000 -d10s 'http://localhost:4000/' Running 10s test @ http://localhost:4000/ 5 threads and 50 connections Thread Stats Avg Stdev Max +/- Stdev Latency 4.15ms 0.92ms 15.06ms 67.75% Req/Sec -nan -nan 0.00 0.00% 10002 requests in 10.00s, 38.59MB read Requests/sec: 999.73 Transfer/sec: 3.86MB $ wrk2 -t5 -c50 -R 1000 -d10s 'http://localhost:4000/' Running 10s test @ http://localhost:4000/ 5 threads and 50 connections Thread Stats Avg Stdev Max +/- Stdev Latency 4.23ms 1.31ms 29.82ms 84.14% Req/Sec -nan -nan 0.00 0.00% 10001 requests in 10.00s, 38.59MB read Requests/sec: 999.82 Transfer/sec: 3.86MBWith PromEx metrics collection:$ wrk2 -t5 -c50 -R 1000 -d10s 'http://localhost:4000/' Running 10s test @ http://localhost:4000/ 5 threads and 50 connections Thread Stats Avg Stdev Max +/- Stdev Latency 4.55ms 1.69ms 36.86ms 94.40% Req/Sec -nan -nan 0.00 0.00% 9999 requests in 10.00s, 38.58MB read Requests/sec: 1000.11 Transfer/sec: 3.86MB $ wrk2 -t5 -c50 -R 1000 -d10s 'http://localhost:4000/' Running 10s test @ http://localhost:4000/ 5 threads and 50 connections Thread Stats Avg Stdev Max +/- Stdev Latency 4.42ms 1.56ms 31.58ms 90.48% Req/Sec -nan -nan 0.00 0.00% 10004 requests in 10.00s, 38.60MB read Requests/sec: 999.93 Transfer/sec: 3.86MB $ wrk2 -t5 -c50 -R 1000 -d10s 'http://localhost:4000/' Running 10s test @ http://localhost:4000/ 5 threads and 50 connections Thread Stats Avg Stdev Max +/- Stdev Latency 4.39ms 1.09ms 18.56ms 72.96% Req/Sec -nan -nan 0.00 0.00% 10001 requests in 10.00s, 38.59MB read Requests/sec: 999.81 Transfer/sec: 3.86MBAttributionIt wouldn't be right to not include somewhere in this project a &quot;thanks&quot; to the various projects that helped make this possible:The various projects available in BEAM TelemetryAll of the Prometheus libraries that Ilya Khaprov (@deadtrickster) maintainsThe logo for the project is an edited version of an SVG image from the unDraw project","ref":"readme.html#installation","title":"PromEx - Installation","type":"extras"},{"doc":"Writing PromEx PluginsThis guide will walk you through writing a PromEx plugin. Whether this plugin is for a dependent library or for your internal application metrics, the same patterns apply.","ref":"writing-promex-plugins.html","title":"Writing PromEx Plugins","type":"extras"},{"doc":"In order for PromEx to be able to load the appropriate metrics from your plugins, your modules need to leverage the PromEx behaviour. This behaviour defines 3 optional callbacks. Those callbacks are: event_metrics/1 polling_metrics/1 manual_metrics/1Each of these callbacks is supposed to return a list of metrics of that type. For example, polling_metrics/1 needs to return a list of PromEx.MetricTypes.Polling structs (a single struct is also an acceptable return). By doing this, you plugin can load your metrics and deal with the nuances of each metric type properly. Each of the MetricTypes structs all have a field called :metrics. This field contains a list of all the Telemetry.Metrics definitions that were provided to the struct build function.","ref":"writing-promex-plugins.html#getting-started","title":"Writing PromEx Plugins - Getting started","type":"extras"},{"doc":"To have your custom plugin expose event based metrics, implement a event_metrics/1 function and build our a collection of Telemetry.Metrics structs (distribution, counter, last_value, and sum). Be sure to look at plugins like PromEx.Plugins.Phoenix for more in depth examples.defmodule MyApp.PromEx.Plugins.MyPhoenix do use PromEx @impl true def event_metrics(opts) do http_metrics_tags = gen_http_metrics_tags(opts) phoenix_router = get_phoenix_router(opts) phoenix_stop_event = [:phoenix, :endpoint, :stop] Event.build( :phoenix_http_event_metrics, [ # Capture request duration information distribution( [:phoenix, :http, :request, :duration, :milliseconds], event_name: phoenix_stop_event, measurement: :duration, description: &quot;The time it takes for the application to respond to HTTP requests.&quot;, reporter_options: [ buckets: exponential(1, 2, 12) ], tag_values: get_conn_tags(phoenix_router), tags: http_metrics_tags, unit: {:native, :millisecond} ) # Additional event based metrics ... ] ) end end","ref":"writing-promex-plugins.html#adding-event-metrics","title":"Writing PromEx Plugins - Adding Event Metrics","type":"extras"},{"doc":"Polling metrics are similar to event metrics in that they require similar fields (group_name and metrics to be specific). In addition, the PromEx.MetricTypes.Polling.build/4 function requires an measurements_mfa argument which specifies what function will be executed on the polling interval. This function should run :telemetry.execute/3 somewhere in its function body. Once that event is executed, the corresponding event in the struct will be triggered and you will capture the desired data point. The following example from PromEx.Plugins.Beam should highlight this concept:defmodule PromEx.Plugins.Beam do use PromEx @memory_event [:prom_ex, :plugin, :beam, :memory] @impl true def polling_metrics(opts) do poll_rate = Keyword.get(opts, :poll_rate, 5_000) [ memory_metrics(poll_rate) ] end defp memory_metrics(poll_rate) do Polling.build( :beam_memory_polling_events, poll_rate, {__MODULE__, :execute_memory_metrics, []}, [ # Capture the total memory allocated to the entire Erlang VM (or BEAM for short) last_value( [:beam, :memory, :total, :kilobytes], event_name: @memory_event, description: &quot;The total amount of memory currently allocated.&quot;, measurement: :total, unit: {:byte, :kilobyte} ) # More memory metrics here ] ) end @doc false def execute_memory_metrics do memory_measurements = :erlang.memory() |&gt; Map.new() :telemetry.execute(@memory_event, memory_measurements, %{}) end endDepending on what :poll_rate value you pass to the initialization tuple for PromEx.Plugins.Beam, the execute_memory_metrics/0 function will be execute on that specified interval.","ref":"writing-promex-plugins.html#adding-polling-metrics","title":"Writing PromEx Plugins - Adding Polling Metrics","type":"extras"},{"doc":"Manual metrics behave more or less the same as polling metrics except they do not require a poll rate value. Instead the provided measurements_mfa is called once on application start, and the metrics are only then updated if you make a call to PromEx.ManualMetricsManager.refresh_metrics/1. An example of this can be seen from the PromEx.Plugins.Application plugin:defmodule PromEx.Plugins.Application do use PromEx @impl true def manual_metrics(opts) do otp_app = Keyword.fetch!(opts, :otp_app) apps = Keyword.get(opts, :deps, :all) Manual.build( :application_versions_manual_metrics, {__MODULE__, :apps_running, [otp_app, apps]}, [ # Capture information regarding the primary application (i.e the user&#39;s application) last_value( [otp_app | [:application, :primary, :info]], event_name: [otp_app | [:application, :primary, :info]], description: &quot;Information regarding the primary application.&quot;, measurement: :status, tags: [:name, :version, :modules] ) # Additional metrics here ] ) end @doc false def apps_running(otp_app, apps) do ... # Emit primary app details :telemetry.execute( [otp_app | [:application, :primary, :info]], %{ status: if(Map.has_key?(started_apps, otp_app), do: 1, else: 0) }, %{ name: otp_app, version: Map.get_lazy(started_apps, otp_app, fn -&gt; Map.get(loaded_only_apps, otp_app, &quot;undefined&quot;) end), modules: length(Application.spec(otp_app)[:modules]) } ) end endSo in this example, apps_running/2 is the function that is denoted by the MFA and will be called once automatically on application start, but then at that point it is up to the user to refresh the data point.","ref":"writing-promex-plugins.html#adding-manual-metrics","title":"Writing PromEx Plugins - Adding Manual Metrics","type":"extras"}]